/* ultoa_fast() test with table of patterns.  Basis are: 8,10,16.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

/* Compare with pattern.	*/
static int cmp (unsigned long val, int base, const char * pattern)
{
    char s[13];
    char *p;
    
    p = ultoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;
    return 0;
}

int main ()
{
    static struct t_s {
	unsigned long val;
	int base;
	char s[13];		/* pattern	*/
    } t[] = {

	{ 0, 10,	"0" },
	{ 0, 8,		"0" },
	{ 0, 16,	"0" },
	
	{ 1, 10,	"1" },
	{ 1, 8,		"1" },
	{ 1, 16,	"1" },
	
	{ 0xffffffff,	10, "4294967295" },
	{ 0xffffffff,	8, "37777777777" },
	{ 0xffffffff,	16,   "ffffffff" },
	
	/* Nonsensed flags must ignored.	*/
	{ 20, 10 | ~0xff,	"20" },
	{ -1, 10 | ~0xff,	"4294967295" },
	{ 20, 8 | (~0xff ^ XTOA_PREFIX),	"24" },
	{ -1, 8 | (~0xff ^ XTOA_PREFIX),	"37777777777" },
	{ 20, 16 | (~0xff ^ (XTOA_PREFIX | XTOA_UPPER)),	"14" },
	{ -1, 16 | (~0xff ^ (XTOA_PREFIX | XTOA_UPPER)),	"ffffffff" },
	
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->base, p->s))
	    exit(i);
    }
    
    return 0;
}
