/* ltoa_fast() test with table #2 of patterns.  Basis are: 8,10,16.
   RAM restriction is a reason of spliting.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

/* Compare with pattern.	*/
static int cmp (long val, int base, const char * pattern)
{
    char s[13];
    char *p;
    
    p = ltoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;
    return 0;
}

int main ()
{
    static struct t_s {
	long val;
	int base;
	char s[13];		/* pattern	*/
    } t[] = {

	/* Nonsensed flags must ignored.	*/
	{ 20, 10 | ~0xff,	"20" },
	{ -2, 10 | ~0xff,	"-2" },
	{ 20, 8 | (~0xff ^ XTOA_PREFIX),	"24" },
	{ -2, 8 | (~0xff ^ XTOA_PREFIX),	"37777777776" },
	{ 20, 16 | (~0xff ^ (XTOA_PREFIX | XTOA_UPPER)),	"14" },
	{ -2, 16 | (~0xff ^ (XTOA_PREFIX | XTOA_UPPER)),	"fffffffe" },
	
	/* prefix for octal	*/
	{ 0, 8 | XTOA_PREFIX,		"0" },
	{ 1, 8 | XTOA_PREFIX,		"01" },
	{ -1, 8 | XTOA_PREFIX,		"037777777777" },
	
	/* prefix for hex	*/
	{ 0, 16 | XTOA_PREFIX,		"0" },
	{ 1, 16 | XTOA_PREFIX,		"0x1" },
	{ -1, 16 | XTOA_PREFIX,		"0xffffffff" },
	
	/* upper for hex	*/
	{ 0xabcdef, 16 | XTOA_UPPER,			"ABCDEF" },
	{ 0xabcdef, 16 | XTOA_UPPER | XTOA_PREFIX,	"0XABCDEF" },
	{ 0x2,      16 | XTOA_UPPER | XTOA_PREFIX,	"0X2" },
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->base, p->s))
	    exit(i);
    }
    
    return 0;
}
