/* (u)ltoa_fast() test with table of patterns.  Base is 2.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

/* Compare with pattern.	*/
static int cmp (unsigned long val, int base, const char * pattern)
{
    char s[33];
    char *p;
    
    p = ultoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = ltoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	unsigned long val;
	int base;
	char s[33];		/* pattern	*/
    } t[] = {

	{ 0, 2,		"0" },
	{ 1, 2,		"1" },
	{ 2, 2,		"10" },
	{ 0x7fffffff, 2,	"1111111111111111111111111111111" },
	{ 0x80000000, 2,	"10000000000000000000000000000000" },
	{ 0x80000001, 2,	"10000000000000000000000000000001" },
	{ 0xfffffffe, 2,	"11111111111111111111111111111110" },
	{ 0xffffffff, 2,	"11111111111111111111111111111111" },
	
	/* Nonsensed flags must ignored.	*/
	{ 3, 2 | ~0xff,		"11" },
	{ -1, 2 | ~0xff,	"11111111111111111111111111111111" },

    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->base, p->s))
	    exit(i);
    }
    
    return 0;
}
